## gitlab-ci-multi-runner 10.5.0+dfsg

=== Makefile ===
NAME ?= gitlab-runner
PACKAGE_NAME ?= $(NAME)
export VERSION := $(shell ./ci/version)
REVISION := $(shell git rev-parse --short=8 HEAD || echo unknown)
BRANCH := $(shell git show-ref | grep "$(REVISION)" | grep -v HEAD | awk '{print $$2}' | sed 's|refs/remotes/origin/||' | sed 's|refs/heads/||' | sort | head -n 1)
BUILT := $(shell date +%Y-%m-%dT%H:%M:%S%:z)
TESTFLAGS ?= -cover

LATEST_STABLE_TAG := $(shell git -c versionsort.prereleaseSuffix="-rc" -c versionsort.prereleaseSuffix="-RC" tag -l "v*.*.*" --sort=-v:refname | awk '!/rc/' | head -n 1)
export IS_LATEST :=
ifeq ($(shell git describe --exact-match --match $(LATEST_STABLE_TAG) >/dev/null 2>&1; echo $$?), 0)
export IS_LATEST := true
endif

PACKAGE_CLOUD ?= ayufan/gitlab-ci-multi-runner
PACKAGE_CLOUD_URL ?= https://packagecloud.io/
BUILD_PLATFORMS ?= -os '!netbsd' -os '!openbsd'
S3_UPLOAD_PATH ?= master
# Keep in sync with docs/install/linux-repository.md
DEB_PLATFORMS ?= debian/wheezy debian/jessie debian/stretch debian/buster \
    ubuntu/trusty ubuntu/xenial ubuntu/zesty ubuntu/artful \
    raspbian/wheezy raspbian/jessie raspbian/stretch raspbian/buster \
    linuxmint/qiana linuxmint/rebecca linuxmint/rafaela linuxmint/rosa linuxmint/sarah linuxmint/serena linuxmint/sonya
DEB_ARCHS ?= amd64 i386 armel armhf
RPM_PLATFORMS ?= el/6 el/7 \
    ol/6 ol/7 \
    fedora/25 fedora/26
RPM_ARCHS ?= x86_64 i686 arm armhf

PKG = gitlab.com/gitlab-org/$(PACKAGE_NAME)
COMMON_PACKAGE_NAMESPACE=$(PKG)/common

BUILD_DIR := $(CURDIR)
TARGET_DIR := $(BUILD_DIR)/out

ORIGINAL_GOPATH = $(shell echo $$GOPATH)
LOCAL_GOPATH := $(CURDIR)/.gopath
GOPATH_SETUP := $(LOCAL_GOPATH)/.ok
GOPATH_BIN := $(LOCAL_GOPATH)/bin
PKG_BUILD_DIR := $(LOCAL_GOPATH)/src/$(PKG)

export GOPATH = $(LOCAL_GOPATH)
export PATH := $(GOPATH_BIN):$(PATH)

# Packages in vendor/ are included in ./...
# https://github.com/golang/go/issues/11659
OUR_PACKAGES ?= $(subst _$(BUILD_DIR),$(PKG),$(shell go list ./... | grep -v '/vendor/'))

GO_LDFLAGS ?= -X $(COMMON_PACKAGE_NAMESPACE).NAME=$(PACKAGE_NAME) -X $(COMMON_PACKAGE_NAMESPACE).VERSION=$(VERSION) \
              -X $(COMMON_PACKAGE_NAMESPACE).REVISION=$(REVISION) -X $(COMMON_PACKAGE_NAMESPACE).BUILT=$(BUILT) \
              -X $(COMMON_PACKAGE_NAMESPACE).BRANCH=$(BRANCH) \
              -s -w
GO_FILES ?= $(shell find . -name '*.go' | grep -v './.gopath/')
export CGO_ENABLED ?= 0


# Development Tools
GOVENDOR = $(GOPATH_BIN)/govendor
GOX = $(GOPATH_BIN)/gox
GOBINDATA = $(GOPATH_BIN)/go-bindata
MOCKERY = $(GOPATH_BIN)/mockery
DEVELOPMENT_TOOLS = $(GOVENDOR) $(GOX) $(GOBINDATA) $(MOCKERY)

MOCKERY_FLAGS = -note="This comment works around https://github.com/vektra/mockery/issues/155"

.PHONY: clean version mocks

all: deps build

help:
	# Commands:
	# make all => deps build
	# make version - show information about current version
	#
	# Development commands:
	# make install - install the version suitable for your OS as gitlab-runner
	# make docker - build docker dependencies
	#
	# Testing commands:
	# make test - run project tests
	# make codequality - run code quality analysis
	#
	# Deployment commands:
	# make deps - install all dependencies
	# make build - build project for all supported OSes
	# make package - package project using FPM
	# make packagecloud - send all packages to packagecloud
	# make packagecloud-yank - remove specific version from packagecloud

version:
	@echo Current version: $(VERSION)
	@echo Current revision: $(REVISION)
	@echo Current branch: $(BRANCH)
	@echo Build platforms: $(BUILD_PLATFORMS)
	@echo DEB platforms: $(DEB_PLATFORMS)
	@echo RPM platforms: $(RPM_PLATFORMS)
	@echo IS_LATEST: $(IS_LATEST)

deps: $(DEVELOPMENT_TOOLS)

codequality:
	./scripts/codequality analyze --dev

out/docker/prebuilt-x86_64.tar.xz: $(GO_FILES) $(GOX)
	# Create directory
	mkdir -p out/docker

ifneq (, $(shell docker info))
	# Building gitlab-runner-helper
	gox -osarch=linux/amd64 \
		-ldflags "$(GO_LDFLAGS)" \
		-output="dockerfiles/build/gitlab-runner-helper" \
		$(PKG)/apps/gitlab-runner-helper

	# Build docker images
	docker build -t gitlab/gitlab-runner-helper:x86_64-$(REVISION) -f dockerfiles/build/Dockerfile.x86_64 dockerfiles/build
	-docker rm -f gitlab-runner-prebuilt-x86_64-$(REVISION)
	docker create --name=gitlab-runner-prebuilt-x86_64-$(REVISION) gitlab/gitlab-runner-helper:x86_64-$(REVISION) /bin/sh
	docker export -o out/docker/prebuilt-x86_64.tar gitlab-runner-prebuilt-x86_64-$(REVISION)
	docker rm -f gitlab-runner-prebuilt-x86_64-$(REVISION)
	xz -f -9 out/docker/prebuilt-x86_64.tar
else
	$(warning =============================================)
	$(warning WARNING: downloading prebuilt docker images that will be embedded in gitlab-runner)
	$(warning WARNING: to use images compiled from your code install Docker Engine)
	$(warning WARNING: and remove out/docker/prebuilt-x86_64.tar.xz)
	$(warning =============================================)
	curl -o out/docker/prebuilt-x86_64.tar.xz \
		https://gitlab-runner-downloads.s3.amazonaws.com/master/docker/prebuilt-x86_64.tar.xz
endif

out/docker/prebuilt-arm.tar.xz: $(GO_FILES) $(GOX)
	# Create directory
	mkdir -p out/docker

ifneq (, $(shell docker info))
	# Building gitlab-runner-helper
	gox -osarch=linux/arm \
		-ldflags "$(GO_LDFLAGS)" \
		-output="dockerfiles/build/gitlab-runner-helper" \
		$(PKG)/apps/gitlab-runner-helper

	# Build docker images
	docker build -t gitlab/gitlab-runner-helper:arm-$(REVISION) -f dockerfiles/build/Dockerfile.arm dockerfiles/build
	-docker rm -f gitlab-runner-prebuilt-arm-$(REVISION)
	docker create --name=gitlab-runner-prebuilt-arm-$(REVISION) gitlab/gitlab-runner-helper:arm-$(REVISION) /bin/sh
	docker export -o out/docker/prebuilt-arm.tar gitlab-runner-prebuilt-arm-$(REVISION)
	docker rm -f gitlab-runner-prebuilt-arm-$(REVISION)
	xz -f -9 out/docker/prebuilt-arm.tar
else
	$(warning =============================================)
	$(warning WARNING: downloading prebuilt docker images that will be embedded in gitlab-runner)
	$(warning WARNING: to use images compiled from your code install Docker Engine)
	$(warning WARNING: and remove out/docker/prebuilt-arm.tar.xz)
	$(warning =============================================)
	curl -o out/docker/prebuilt-arm.tar.xz \
		https://gitlab-runner-downloads.s3.amazonaws.com/master/docker/prebuilt-arm.tar.xz
endif

executors/docker/bindata.go: out/docker/prebuilt-x86_64.tar.xz out/docker/prebuilt-arm.tar.xz $(GOBINDATA)
	# Generating embedded data
	go-bindata \
		-pkg docker \
		-nocompress \
		-nomemcopy \
		-nometadata \
		-prefix out/docker/ \
		-o executors/docker/bindata.go \
		out/docker/prebuilt-x86_64.tar.xz \
		out/docker/prebuilt-arm.tar.xz
	go fmt executors/docker/bindata.go

docker: executors/docker/bindata.go

build: executors/docker/bindata.go $(GOX)
	# Building $(NAME) in version $(VERSION) for $(BUILD_PLATFORMS)
	gox $(BUILD_PLATFORMS) \
		-ldflags "$(GO_LDFLAGS)" \
		-output="out/binaries/$(NAME)-{{.OS}}-{{.Arch}}" \
		$(PKG)

build_simple: $(GOPATH_SETUP)
	# Building $(NAME) in version $(VERSION) for current platform
	go build \
		-ldflags "$(GO_LDFLAGS)" \
		-o "out/binaries/$(NAME)" \
		$(PKG)

build_current: executors/docker/bindata.go build_simple

check_race_conditions: executors/docker/bindata.go
	@./scripts/check_race_conditions $(OUR_PACKAGES)

test: executors/docker/bindata.go
	# Running tests...
	go test $(OUR_PACKAGES) $(TESTFLAGS)

install: executors/docker/bindata.go
	go install --ldflags="$(GO_LDFLAGS)" $(PKG)

dockerfiles:
	make -C dockerfiles all

# We rely on user GOPATH 'cause mockery seems not to be able to find dependencies in vendor directory
mocks: $(MOCKERY)
	rm -rf ./helpers/service/mocks
	find . -type f -name 'mock_*' -delete
	GOPATH=$(ORIGINAL_GOPATH) mockery $(MOCKERY_FLAGS) -dir=./vendor/github.com/ayufan/golang-kardianos-service -output=./helpers/service/mocks -name='(Interface|Logger)'
	GOPATH=$(ORIGINAL_GOPATH) mockery $(MOCKERY_FLAGS) -dir=./helpers/docker -all -inpkg
	GOPATH=$(ORIGINAL_GOPATH) mockery $(MOCKERY_FLAGS) -dir=./common -all -inpkg

test-docker:
	make test-docker-image IMAGE=centos:6 TYPE=rpm
	make test-docker-image IMAGE=centos:7 TYPE=rpm
	make test-docker-image IMAGE=debian:wheezy TYPE=deb
	make test-docker-image IMAGE=debian:jessie TYPE=deb
	make test-docker-image IMAGE=ubuntu-upstart:precise TYPE=deb
	make test-docker-image IMAGE=ubuntu-upstart:trusty TYPE=deb
	make test-docker-image IMAGE=ubuntu-upstart:utopic TYPE=deb

test-docker-image:
	tests/test_installation.sh $(IMAGE) out/$(TYPE)/$(PACKAGE_NAME)_amd64.$(TYPE)
	tests/test_installation.sh $(IMAGE) out/$(TYPE)/$(PACKAGE_NAME)_amd64.$(TYPE) Y

build-and-deploy:
	make build BUILD_PLATFORMS="-os=linux -arch=amd64"
	make package-deb-fpm ARCH=amd64 PACKAGE_ARCH=amd64
	scp out/deb/$(PACKAGE_NAME)_amd64.deb $(SERVER):
	ssh $(SERVER) dpkg -i $(PACKAGE_NAME)_amd64.deb

build-and-deploy-binary:
	make build BUILD_PLATFORMS="-os=linux -arch=amd64"
	scp out/binaries/$(PACKAGE_NAME)-linux-amd64 $(SERVER):/usr/bin/gitlab-runner

package: package-deps package-prepare package-deb package-rpm

package-deps:
	# Installing packaging dependencies...
	gem install fpm --no-ri --no-rdoc

package-prepare:
	chmod 755 packaging/root/usr/share/gitlab-runner/
	chmod 755 packaging/root/usr/share/gitlab-runner/*

package-deb: package-deps package-prepare
	# Building Debian compatible packages...
	make package-deb-fpm ARCH=amd64 PACKAGE_ARCH=amd64
	make package-deb-fpm ARCH=386 PACKAGE_ARCH=i386
	make package-deb-fpm ARCH=arm PACKAGE_ARCH=armel
	make package-deb-fpm ARCH=arm PACKAGE_ARCH=armhf

package-rpm: package-deps package-prepare
	# Building RedHat compatible packages...
	make package-rpm-fpm ARCH=amd64 PACKAGE_ARCH=amd64
	make package-rpm-fpm ARCH=386 PACKAGE_ARCH=i686
	make package-rpm-fpm ARCH=arm PACKAGE_ARCH=arm
	make package-rpm-fpm ARCH=arm PACKAGE_ARCH=armhf

package-deb-fpm:
	@mkdir -p out/deb/
	fpm -s dir -t deb -n $(PACKAGE_NAME) -v $(VERSION) \
		-p out/deb/$(PACKAGE_NAME)_$(PACKAGE_ARCH).deb \
		--deb-priority optional --category admin \
		--force \
		--deb-compression bzip2 \
		--after-install packaging/scripts/postinst.deb \
		--before-remove packaging/scripts/prerm.deb \
		--url https://gitlab.com/gitlab-org/gitlab-runner \
		--description "GitLab Runner" \
		-m "GitLab Inc. <support@gitlab.com>" \
		--license "MIT" \
		--vendor "GitLab Inc." \
		--conflicts $(PACKAGE_NAME)-beta \
		--conflicts gitlab-ci-multi-runner \
		--conflicts gitlab-ci-multi-runner-beta \
		--provides gitlab-ci-multi-runner \
		--replaces gitlab-ci-multi-runner \
		--depends ca-certificates \
		--depends git \
		--depends curl \
		--depends tar \
		--deb-suggests docker-engine \
		-a $(PACKAGE_ARCH) \
		packaging/root/=/ \
		out/binaries/$(NAME)-linux-$(ARCH)=/usr/bin/gitlab-runner

package-rpm-fpm:
	@mkdir -p out/rpm/
	fpm -s dir -t rpm -n $(PACKAGE_NAME) -v $(VERSION) \
		-p out/rpm/$(PACKAGE_NAME)_$(PACKAGE_ARCH).rpm \
		--rpm-compression bzip2 --rpm-os linux \
		--force \
		--after-install packaging/scripts/postinst.rpm \
		--before-remove packaging/scripts/prerm.rpm \
		--url https://gitlab.com/gitlab-org/gitlab-runner \
		--description "GitLab Runner" \
		-m "GitLab Inc. <support@gitlab.com>" \
		--license "MIT" \
		--vendor "GitLab Inc." \
		--conflicts $(PACKAGE_NAME)-beta \
		--conflicts gitlab-ci-multi-runner \
		--conflicts gitlab-ci-multi-runner-beta \
		--provides gitlab-ci-multi-runner \
		--replaces gitlab-ci-multi-runner \
		--depends git \
		--depends curl \
		--depends tar \
		-a $(PACKAGE_ARCH) \
		packaging/root/=/ \
		out/binaries/$(NAME)-linux-$(ARCH)=/usr/bin/gitlab-runner

packagecloud: packagecloud-deps packagecloud-deb packagecloud-rpm

packagecloud-deps:
	# Installing packagecloud dependencies...
	gem install package_cloud --no-ri --no-rdoc

packagecloud-deb:
	# Sending Debian compatible packages...
	-for DIST in $(DEB_PLATFORMS); do \
		package_cloud push --url $(PACKAGE_CLOUD_URL) $(PACKAGE_CLOUD)/$$DIST out/deb/*.deb; \
	done

packagecloud-rpm:

=== debian/changelog ===
gitlab-ci-multi-runner (10.5.0+dfsg-2) unstable; urgency=medium

  * Upload to unstable.
  * postinst: remove broken "gitlab-runner.service" symlink if upgraded
    from "gitlab-ci-multi-runner".
  * New patch to fix test failure on [armel, armhf].

 -- Dmitry Smirnov <onlyjob@debian.org>  Mon, 26 Mar 2018 01:08:26 +1100

gitlab-ci-multi-runner (10.5.0+dfsg-1) experimental; urgency=medium

  * New upstream release [February 2018].
  * Build-Depends:
    - golang-github-codegangsta-cli-dev
    + golang-github-urfave-cli-dev
    + golang-github-go-ini-ini-dev
    + golang-github-mattn-go-zglob-dev
  * Renamed binary package: gitlab-ci-multi-runner --> gitlab-runner.
  * rules: set/embed package VERSION.

 -- Dmitry Smirnov <onlyjob@debian.org>  Wed, 21 Mar 2018 11:59:10 +1100

gitlab-ci-multi-runner (9.5.1+dfsg-2) unstable; urgency=medium

  * Upload to unstable.
  * New patch to fix FTBFS on mips.
  * Updated URLs in "bug-presubj".
  * Build-Depends:
    - golang-github-docker-docker-dev
    * golang-github-docker-distribution-dev (>= 2.6.2~)
    * golang-github-docker-go-connections-dev (>= 0.3.0~)
    * golang-github-docker-docker-credential-helpers-dev (>= 0.5.0~)
  * NEWS file updated with link to snapshot.debian.org where
    GitLab v8 - compatible runner v1.11.4 packages can be found.

 -- Dmitry Smirnov <onlyjob@debian.org>  Mon, 19 Mar 2018 22:13:11 +1100

gitlab-ci-multi-runner (9.5.1+dfsg-1) experimental; urgency=medium

  * New upstream release [October 2017].
  * Build-Depends:
    + golang-github-azure-go-ansiterm-dev
    + golang-github-gorilla-context-dev
    + golang-github-hashicorp-go-version-dev
    + golang-github-vbatts-tar-split-dev
    + golang-github-gorilla-mux-dev
    + golang-github-docker-docker-credential-helpers-dev
    + golang-github-emicklei-go-restful-swagger12-dev
    - golang-github-opencontainers-runc-dev
    + golang-github-opencontainers-docker-runc-dev
    - golang-github-stretchr-testify-dev
    + golang-github-stretchr-testify-dev (>= 1.2.1~)
  * Priority: optional
  * Standards-Version: 4.1.3
  * debhelper & compat to versions 11.
  * Use "vendor/github.com/opencontainers/runtime-spec" to fix FTBFS.
  * New "swagger.patch" to fix FTBFS (Closes: #891279).
  * Updated Homepage URL.
  * rules:
    + remove all .generated.go files (Closes: #891739).
    + removed calls to dpkg-parsechangelog.
    + added "DH_GOLANG_GO_GENERATE := 1".
  * watch file is fixed and updated for new upstream repository location.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 18 Mar 2018 13:37:52 +1100

gitlab-ci-multi-runner (9.1.1+dfsg-1) experimental; urgency=medium

  * New upstream release [May 2017].
  * mk-prebuilt-images.sh: generate importable (not loadable) Docker
    image to reduce downstream burden of patches.
  * Temporary switched to bundled "github.com/docker/docker" as recent
    enough version is not available on i386.
  * Build-Depends:
    + golang-github-docker-go-connections-dev
    + golang-github-docker-engine-api-dev
    + golang-github-pkg-errors-dev
    + golang-github-pmezard-go-difflib-dev
    - golang-github-fsouza-go-dockerclient-dev

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 27 May 2017 21:41:18 +1000

=== debian/control ===
Source: gitlab-ci-multi-runner
Section: devel
Priority: optional
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Dmitry Smirnov <onlyjob@debian.org>
Build-Depends: debhelper (>= 11~) ,dh-golang
              ,golang-go (>= 2:1.7~)
    ,golang-github-azure-go-ansiterm-dev
    ,golang-github-blang-semver-dev
    ,golang-github-burntsushi-toml-dev
    ,golang-github-urfave-cli-dev
    ,golang-github-coreos-go-oidc-dev (>= 0.0~git20160926~)
#~  ,golang-github-docker-docker-dev
    ,golang-github-docker-docker-credential-helpers-dev (>= 0.5.0~)
    ,golang-github-docker-go-connections-dev (>= 0.3.0~)
    ,golang-github-docker-engine-api-dev
    ,golang-github-docker-distribution-dev (>= 2.6.2~)
    ,golang-github-docker-spdystream-dev
    ,golang-github-emicklei-go-restful-dev (>= 2.4.0~)
    ,golang-github-emicklei-go-restful-swagger12-dev
    ,golang-github-go-ini-ini-dev
    ,golang-github-getsentry-raven-go-dev
    ,golang-github-ghodss-yaml-dev
    ,golang-github-google-cadvisor-dev
    ,golang-github-google-gofuzz-dev
    ,golang-github-gorhill-cronexpr-dev
    ,golang-github-gorilla-context-dev
    ,golang-github-gorilla-mux-dev
    ,golang-github-hashicorp-go-version-dev
    ,golang-github-imdario-mergo-dev
    ,golang-github-juju-ratelimit-dev
    ,golang-github-kardianos-osext-dev
    ,golang-github-mattn-go-zglob-dev
    ,golang-github-minio-minio-go-dev
    ,golang-github-opencontainers-docker-runc-dev
#~  ,golang-github-opencontainers-specs-dev
    ,golang-github-pborman-uuid-dev
    ,golang-github-pkg-errors-dev
    ,golang-github-pmezard-go-difflib-dev
    ,golang-github-prometheus-client-golang-dev
    ,golang-github-sirupsen-logrus-dev
    ,golang-github-spf13-pflag-dev
    ,golang-github-stretchr-testify-dev (>= 1.2.1~)
#   ,golang-github-ugorji-go-codec
    ,golang-github-vbatts-tar-split-dev
    ,golang-golang-x-crypto-dev
    ,golang-golang-x-oauth2-google-dev
    ,golang-gopkg-inf.v0-dev
    ,golang-yaml.v2-dev
# tests:
    ,ca-certificates
    ,git
    ,golang-github-golang-mock-dev
Standards-Version: 4.1.3
Homepage: https://gitlab.com/gitlab-org/gitlab-runner
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-go/packages/gitlab-ci-multi-runner.git
Vcs-Git: https://anonscm.debian.org/git/pkg-go/packages/gitlab-ci-multi-runner.git
XS-Go-Import-Path: gitlab.com/gitlab-org/gitlab-ci-multi-runner

Package: gitlab-runner
Provides: gitlab-ci-multi-runner
Conflicts: gitlab-ci-multi-runner
Breaks: gitlab-ci-multi-runner
Replaces: gitlab-ci-multi-runner
Architecture: any
Built-Using: ${misc:Built-Using}
Depends: ${shlibs:Depends},
         ${misc:Depends}
    ,adduser
    ,ca-certificates
#    ,curl
    ,git
    ,lsb-base
Recommends: ${misc:Recommends}
    ,cdebootstrap
Suggests: ${misc:Suggests}
    ,docker.io
Description: GitLab Runner - runs continuous integration (CI) jobs
 GitLab Runner runs tests and sends the results to GitLab.
 GitLab Continuous Integration (CI) service (included with GitLab)
 coordinates the testing.

=== debian/watch ===
# uscan(1) configuration file.
version=4

opts="\
pgpmode=none,\
repacksuffix=+dfsg,\
repack,compression=xz,\
dversionmangle=s{[+~]dfsg\d*}{},\
" https://gitlab.com/gitlab-org/gitlab-runner/tags \
  .*/v?(\d[\.\d]*)/archive\.tar\.bz2

## gitlab-ci-multi-runner 10.7.1+dfsg

=== Makefile ===
--- 
+++ 
@@ -18,7 +18,7 @@
 S3_UPLOAD_PATH ?= master
 # Keep in sync with docs/install/linux-repository.md
 DEB_PLATFORMS ?= debian/wheezy debian/jessie debian/stretch debian/buster \
-    ubuntu/trusty ubuntu/xenial ubuntu/zesty ubuntu/artful \
+    ubuntu/trusty ubuntu/xenial ubuntu/zesty ubuntu/artful ubuntu/bionic \
     raspbian/wheezy raspbian/jessie raspbian/stretch raspbian/buster \
     linuxmint/qiana linuxmint/rebecca linuxmint/rafaela linuxmint/rosa linuxmint/sarah linuxmint/serena linuxmint/sonya
 DEB_ARCHS ?= amd64 i386 armel armhf
@@ -55,11 +55,10 @@
 
 
 # Development Tools
-GOVENDOR = $(GOPATH_BIN)/govendor
 GOX = $(GOPATH_BIN)/gox
 GOBINDATA = $(GOPATH_BIN)/go-bindata
 MOCKERY = $(GOPATH_BIN)/mockery
-DEVELOPMENT_TOOLS = $(GOVENDOR) $(GOX) $(GOBINDATA) $(MOCKERY)
+DEVELOPMENT_TOOLS = $(GOX) $(GOBINDATA) $(MOCKERY)
 
 MOCKERY_FLAGS = -note="This comment works around https://github.com/vektra/mockery/issues/155"
 
@@ -208,6 +207,7 @@
 	GOPATH=$(ORIGINAL_GOPATH) mockery $(MOCKERY_FLAGS) -dir=./vendor/github.com/ayufan/golang-kardianos-service -output=./helpers/service/mocks -name='(Interface|Logger)'
 	GOPATH=$(ORIGINAL_GOPATH) mockery $(MOCKERY_FLAGS) -dir=./helpers/docker -all -inpkg
 	GOPATH=$(ORIGINAL_GOPATH) mockery $(MOCKERY_FLAGS) -dir=./common -all -inpkg
+	GOPATH=$(ORIGINAL_GOPATH) mockery $(MOCKERY_FLAGS) -dir=./shells -name fakeIAMCredentialsProvider -inpkg
 
 test-docker:
 	make test-docker-image IMAGE=centos:6 TYPE=rpm
@@ -236,7 +236,7 @@
 
 package-deps:
 	# Installing packaging dependencies...
-	gem install fpm --no-ri --no-rdoc
+	gem install rake fpm --no-ri --no-rdoc
 
 package-prepare:
 	chmod 755 packaging/root/usr/share/gitlab-runner/
@@ -313,12 +313,8 @@
 
 packagecloud-deps:
 	# Installing packagecloud dependencies...
-	gem install package_cloud --no-ri --no-rdoc
+	gem install package_cloud --version "~> 0.3.0" --no-ri --no-rdoc
 
 packagecloud-deb:
 	# Sending Debian compatible packages...
 	-for DIST in $(DEB_PLATFORMS); do \
-		package_cloud push --url $(PACKAGE_CLOUD_URL) $(PACKAGE_CLOUD)/$$DIST out/deb/*.deb; \
-	done
-
-packagecloud-rpm:

=== debian/changelog ===
gitlab-ci-multi-runner (10.7.1+dfsg-1) unstable; urgency=medium

  [ Alexandre Viau ]
  * Point Vcs-* urls to salsa.debian.org.

  [ Dmitry Smirnov ]
  * New upstream release.
  * Build-Depends:
    + golang-github-docker-docker-dev
    + golang-github-dustin-go-humanize-dev
    = golang-github-minio-minio-go-dev (>= 4.0.5~)
    = golang-github-sirupsen-logrus-dev (>= 1.0.5~)
    = golang-github-opencontainers-docker-runc-dev (>= 1.0.0~rc2+git+docker1.13.1~ds1-4~)
  * New patch to fix test failure on [mips64el].
  * Standards-Version: 4.1.4.

 -- Dmitry Smirnov <onlyjob@debian.org>  Mon, 07 May 2018 04:16:55 +1000

=== debian/control ===
--- 
+++ 
@@ -8,19 +8,19 @@
     ,golang-github-azure-go-ansiterm-dev
     ,golang-github-blang-semver-dev
     ,golang-github-burntsushi-toml-dev
-    ,golang-github-urfave-cli-dev
     ,golang-github-coreos-go-oidc-dev (>= 0.0~git20160926~)
-#~  ,golang-github-docker-docker-dev
+    ,golang-github-docker-distribution-dev (>= 2.6.2~)
     ,golang-github-docker-docker-credential-helpers-dev (>= 0.5.0~)
+    ,golang-github-docker-docker-dev
+    ,golang-github-docker-engine-api-dev
     ,golang-github-docker-go-connections-dev (>= 0.3.0~)
-    ,golang-github-docker-engine-api-dev
-    ,golang-github-docker-distribution-dev (>= 2.6.2~)
     ,golang-github-docker-spdystream-dev
+    ,golang-github-dustin-go-humanize-dev
     ,golang-github-emicklei-go-restful-dev (>= 2.4.0~)
     ,golang-github-emicklei-go-restful-swagger12-dev
-    ,golang-github-go-ini-ini-dev
     ,golang-github-getsentry-raven-go-dev
     ,golang-github-ghodss-yaml-dev
+    ,golang-github-go-ini-ini-dev
     ,golang-github-google-cadvisor-dev
     ,golang-github-google-gofuzz-dev
     ,golang-github-gorhill-cronexpr-dev
@@ -31,17 +31,17 @@
     ,golang-github-juju-ratelimit-dev
     ,golang-github-kardianos-osext-dev
     ,golang-github-mattn-go-zglob-dev
-    ,golang-github-minio-minio-go-dev
-    ,golang-github-opencontainers-docker-runc-dev
+    ,golang-github-minio-minio-go-dev (>= 4.0.5~)
+    ,golang-github-opencontainers-docker-runc-dev (>= 1.0.0~rc2+git+docker1.13.1~ds1-4~)
 #~  ,golang-github-opencontainers-specs-dev
     ,golang-github-pborman-uuid-dev
     ,golang-github-pkg-errors-dev
     ,golang-github-pmezard-go-difflib-dev
     ,golang-github-prometheus-client-golang-dev
-    ,golang-github-sirupsen-logrus-dev
+    ,golang-github-sirupsen-logrus-dev (>= 1.0.5~)
     ,golang-github-spf13-pflag-dev
     ,golang-github-stretchr-testify-dev (>= 1.2.1~)
-#   ,golang-github-ugorji-go-codec
+    ,golang-github-urfave-cli-dev
     ,golang-github-vbatts-tar-split-dev
     ,golang-golang-x-crypto-dev
     ,golang-golang-x-oauth2-google-dev
@@ -51,10 +51,10 @@
     ,ca-certificates
     ,git
     ,golang-github-golang-mock-dev
-Standards-Version: 4.1.3
+Standards-Version: 4.1.4
 Homepage: https://gitlab.com/gitlab-org/gitlab-runner
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-go/packages/gitlab-ci-multi-runner.git
-Vcs-Git: https://anonscm.debian.org/git/pkg-go/packages/gitlab-ci-multi-runner.git
+Vcs-Browser: https://salsa.debian.org/go-team/packages/gitlab-ci-multi-runner
+Vcs-Git: https://salsa.debian.org/go-team/packages/gitlab-ci-multi-runner.git
 XS-Go-Import-Path: gitlab.com/gitlab-org/gitlab-ci-multi-runner
 
 Package: gitlab-runner

## gitlab-ci-multi-runner 10.8.0+dfsg

=== Makefile ===
--- 
+++ 
@@ -16,15 +16,16 @@
 PACKAGE_CLOUD_URL ?= https://packagecloud.io/
 BUILD_PLATFORMS ?= -os '!netbsd' -os '!openbsd'
 S3_UPLOAD_PATH ?= master
+
 # Keep in sync with docs/install/linux-repository.md
 DEB_PLATFORMS ?= debian/wheezy debian/jessie debian/stretch debian/buster \
-    ubuntu/trusty ubuntu/xenial ubuntu/zesty ubuntu/artful ubuntu/bionic \
+    ubuntu/trusty ubuntu/xenial ubuntu/artful ubuntu/bionic \
     raspbian/wheezy raspbian/jessie raspbian/stretch raspbian/buster \
     linuxmint/qiana linuxmint/rebecca linuxmint/rafaela linuxmint/rosa linuxmint/sarah linuxmint/serena linuxmint/sonya
 DEB_ARCHS ?= amd64 i386 armel armhf
 RPM_PLATFORMS ?= el/6 el/7 \
     ol/6 ol/7 \
-    fedora/25 fedora/26
+    fedora/26 fedora/27 fedora/28
 RPM_ARCHS ?= x86_64 i686 arm armhf
 
 PKG = gitlab.com/gitlab-org/$(PACKAGE_NAME)
@@ -203,7 +204,7 @@
 # We rely on user GOPATH 'cause mockery seems not to be able to find dependencies in vendor directory
 mocks: $(MOCKERY)
 	rm -rf ./helpers/service/mocks
-	find . -type f -name 'mock_*' -delete
+	find . -type f ! -path '*vendor/*' -name 'mock_*' -delete
 	GOPATH=$(ORIGINAL_GOPATH) mockery $(MOCKERY_FLAGS) -dir=./vendor/github.com/ayufan/golang-kardianos-service -output=./helpers/service/mocks -name='(Interface|Logger)'
 	GOPATH=$(ORIGINAL_GOPATH) mockery $(MOCKERY_FLAGS) -dir=./helpers/docker -all -inpkg
 	GOPATH=$(ORIGINAL_GOPATH) mockery $(MOCKERY_FLAGS) -dir=./common -all -inpkg

=== debian/changelog ===
gitlab-ci-multi-runner (10.8.0+dfsg-2) unstable; urgency=medium

  * Patch away deprecated "golang-github-docker-engine-api-dev";
    remove the latter from Build-Depends.

 -- Dmitry Smirnov <onlyjob@debian.org>  Thu, 07 Jun 2018 16:59:42 +1000

gitlab-ci-multi-runner (10.8.0+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Dmitry Smirnov <onlyjob@debian.org>  Thu, 07 Jun 2018 13:52:52 +1000

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,6 @@
     ,golang-github-docker-distribution-dev (>= 2.6.2~)
     ,golang-github-docker-docker-credential-helpers-dev (>= 0.5.0~)
     ,golang-github-docker-docker-dev
-    ,golang-github-docker-engine-api-dev
     ,golang-github-docker-go-connections-dev (>= 0.3.0~)
     ,golang-github-docker-spdystream-dev
     ,golang-github-dustin-go-humanize-dev

## gitlab-ci-multi-runner 10.8.0+dfsg1

=== debian/changelog ===
gitlab-ci-multi-runner (10.8.0+dfsg1-3) unstable; urgency=medium

  * Build-Depends:
    - golang-github-docker-distribution-dev
    - golang-github-opencontainers-docker-runc-dev
    + golang-github-opencontainers-runc-dev (>= 1.0.0~)
    + golang-github-opencontainers-specs-dev (>= 1.0.1~)
    = golang-github-docker-docker-dev (>= 17.12.1~)
  * Patcworks:
    - docker-mips.patch
    + docker_client.patch
    + docker_parsehost.patch
  * Repacked orig.tar to remove bundled Docker client.

 -- Dmitry Smirnov <onlyjob@debian.org>  Thu, 21 Jun 2018 09:48:09 +1000

=== debian/control ===
--- 
+++ 
@@ -9,9 +9,8 @@
     ,golang-github-blang-semver-dev
     ,golang-github-burntsushi-toml-dev
     ,golang-github-coreos-go-oidc-dev (>= 0.0~git20160926~)
-    ,golang-github-docker-distribution-dev (>= 2.6.2~)
     ,golang-github-docker-docker-credential-helpers-dev (>= 0.5.0~)
-    ,golang-github-docker-docker-dev
+    ,golang-github-docker-docker-dev (>= 17.12.1~)
     ,golang-github-docker-go-connections-dev (>= 0.3.0~)
     ,golang-github-docker-spdystream-dev
     ,golang-github-dustin-go-humanize-dev
@@ -31,8 +30,8 @@
     ,golang-github-kardianos-osext-dev
     ,golang-github-mattn-go-zglob-dev
     ,golang-github-minio-minio-go-dev (>= 4.0.5~)
-    ,golang-github-opencontainers-docker-runc-dev (>= 1.0.0~rc2+git+docker1.13.1~ds1-4~)
-#~  ,golang-github-opencontainers-specs-dev
+    ,golang-github-opencontainers-runc-dev (>= 1.0.0~)
+    ,golang-github-opencontainers-specs-dev (>= 1.0.1~)
     ,golang-github-pborman-uuid-dev
     ,golang-github-pkg-errors-dev
     ,golang-github-pmezard-go-difflib-dev

=== debian/watch ===
# uscan(1) configuration file.
version=4

opts="\
pgpmode=none,\
repacksuffix=+dfsg1,\
repack,compression=xz,\
dversionmangle=s{[+~]dfsg\d*}{},\
" https://gitlab.com/gitlab-org/gitlab-runner/tags \
  .*/v?(\d[\.\d]*)/gitlab-runner-v?(?:\d[\.\d]*)\.tar\.bz2

## gitlab-ci-multi-runner 11.0.0+dfsg

=== debian/changelog ===
gitlab-ci-multi-runner (11.0.0+dfsg-2) unstable; urgency=medium

  * Patch away "golang-github-kardianos-osext-dev";
    removed the latter from Build-Depends.

 -- Dmitry Smirnov <onlyjob@debian.org>  Wed, 04 Jul 2018 13:56:13 +1000

gitlab-ci-multi-runner (11.0.0+dfsg-1) unstable; urgency=medium

  * New upstream release [June 2018].

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 24 Jun 2018 01:35:27 +1000

=== debian/control ===
--- 
+++ 
@@ -27,7 +27,6 @@
     ,golang-github-hashicorp-go-version-dev
     ,golang-github-imdario-mergo-dev
     ,golang-github-juju-ratelimit-dev
-    ,golang-github-kardianos-osext-dev
     ,golang-github-mattn-go-zglob-dev
     ,golang-github-minio-minio-go-dev (>= 4.0.5~)
     ,golang-github-opencontainers-runc-dev (>= 1.0.0~)

## gitlab-ci-multi-runner 11.2.0+dfsg

=== Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 REVISION := $(shell git rev-parse --short=8 HEAD || echo unknown)
 BRANCH := $(shell git show-ref | grep "$(REVISION)" | grep -v HEAD | awk '{print $$2}' | sed 's|refs/remotes/origin/||' | sed 's|refs/heads/||' | sort | head -n 1)
 BUILT := $(shell date +%Y-%m-%dT%H:%M:%S%:z)
-TESTFLAGS ?= -cover
+export TESTFLAGS ?= -cover
 
 LATEST_STABLE_TAG := $(shell git -c versionsort.prereleaseSuffix="-rc" -c versionsort.prereleaseSuffix="-RC" tag -l "v*.*.*" --sort=-v:refname | awk '!/rc/' | head -n 1)
 export IS_LATEST :=
@@ -45,7 +45,7 @@
 
 # Packages in vendor/ are included in ./...
 # https://github.com/golang/go/issues/11659
-OUR_PACKAGES ?= $(subst _$(BUILD_DIR),$(PKG),$(shell go list ./... | grep -v '/vendor/'))
+export OUR_PACKAGES ?= $(subst _$(BUILD_DIR),$(PKG),$(shell go list ./... | grep -v '/vendor/'))
 
 GO_LDFLAGS ?= -X $(COMMON_PACKAGE_NAMESPACE).NAME=$(PACKAGE_NAME) -X $(COMMON_PACKAGE_NAMESPACE).VERSION=$(VERSION) \
               -X $(COMMON_PACKAGE_NAMESPACE).REVISION=$(REVISION) -X $(COMMON_PACKAGE_NAMESPACE).BUILT=$(BUILT) \
@@ -57,15 +57,16 @@
 
 # Development Tools
 GOX = $(GOPATH_BIN)/gox
-GOBINDATA = $(GOPATH_BIN)/go-bindata
 MOCKERY = $(GOPATH_BIN)/mockery
-DEVELOPMENT_TOOLS = $(GOX) $(GOBINDATA) $(MOCKERY)
+DEVELOPMENT_TOOLS = $(GOX) $(MOCKERY)
 
 MOCKERY_FLAGS = -note="This comment works around https://github.com/vektra/mockery/issues/155"
 
 .PHONY: clean version mocks
 
-all: deps build
+all: deps docker build
+
+include Makefile.docker.mk
 
 help:
 	# Commands:
@@ -101,78 +102,7 @@
 codequality:
 	./scripts/codequality analyze --dev
 
-out/docker/prebuilt-x86_64.tar.xz: $(GO_FILES) $(GOX)
-	# Create directory
-	mkdir -p out/docker
-
-ifneq (, $(shell docker info))
-	# Building gitlab-runner-helper
-	gox -osarch=linux/amd64 \
-		-ldflags "$(GO_LDFLAGS)" \
-		-output="dockerfiles/build/gitlab-runner-helper" \
-		$(PKG)/apps/gitlab-runner-helper
-
-	# Build docker images
-	docker build -t gitlab/gitlab-runner-helper:x86_64-$(REVISION) -f dockerfiles/build/Dockerfile.x86_64 dockerfiles/build
-	-docker rm -f gitlab-runner-prebuilt-x86_64-$(REVISION)
-	docker create --name=gitlab-runner-prebuilt-x86_64-$(REVISION) gitlab/gitlab-runner-helper:x86_64-$(REVISION) /bin/sh
-	docker export -o out/docker/prebuilt-x86_64.tar gitlab-runner-prebuilt-x86_64-$(REVISION)
-	docker rm -f gitlab-runner-prebuilt-x86_64-$(REVISION)
-	xz -f -9 out/docker/prebuilt-x86_64.tar
-else
-	$(warning =============================================)
-	$(warning WARNING: downloading prebuilt docker images that will be embedded in gitlab-runner)
-	$(warning WARNING: to use images compiled from your code install Docker Engine)
-	$(warning WARNING: and remove out/docker/prebuilt-x86_64.tar.xz)
-	$(warning =============================================)
-	curl -o out/docker/prebuilt-x86_64.tar.xz \
-		https://gitlab-runner-downloads.s3.amazonaws.com/master/docker/prebuilt-x86_64.tar.xz
-endif
-
-out/docker/prebuilt-arm.tar.xz: $(GO_FILES) $(GOX)
-	# Create directory
-	mkdir -p out/docker
-
-ifneq (, $(shell docker info))
-	# Building gitlab-runner-helper
-	gox -osarch=linux/arm \
-		-ldflags "$(GO_LDFLAGS)" \
-		-output="dockerfiles/build/gitlab-runner-helper" \
-		$(PKG)/apps/gitlab-runner-helper
-
-	# Build docker images
-	docker build -t gitlab/gitlab-runner-helper:arm-$(REVISION) -f dockerfiles/build/Dockerfile.arm dockerfiles/build
-	-docker rm -f gitlab-runner-prebuilt-arm-$(REVISION)
-	docker create --name=gitlab-runner-prebuilt-arm-$(REVISION) gitlab/gitlab-runner-helper:arm-$(REVISION) /bin/sh
-	docker export -o out/docker/prebuilt-arm.tar gitlab-runner-prebuilt-arm-$(REVISION)
-	docker rm -f gitlab-runner-prebuilt-arm-$(REVISION)
-	xz -f -9 out/docker/prebuilt-arm.tar
-else
-	$(warning =============================================)
-	$(warning WARNING: downloading prebuilt docker images that will be embedded in gitlab-runner)
-	$(warning WARNING: to use images compiled from your code install Docker Engine)
-	$(warning WARNING: and remove out/docker/prebuilt-arm.tar.xz)
-	$(warning =============================================)
-	curl -o out/docker/prebuilt-arm.tar.xz \
-		https://gitlab-runner-downloads.s3.amazonaws.com/master/docker/prebuilt-arm.tar.xz
-endif
-
-executors/docker/bindata.go: out/docker/prebuilt-x86_64.tar.xz out/docker/prebuilt-arm.tar.xz $(GOBINDATA)
-	# Generating embedded data
-	go-bindata \
-		-pkg docker \
-		-nocompress \
-		-nomemcopy \
-		-nometadata \
-		-prefix out/docker/ \
-		-o executors/docker/bindata.go \
-		out/docker/prebuilt-x86_64.tar.xz \
-		out/docker/prebuilt-arm.tar.xz
-	go fmt executors/docker/bindata.go
-
-docker: executors/docker/bindata.go
-
-build: executors/docker/bindata.go $(GOX)
+build: $(GOX)
 	# Building $(NAME) in version $(VERSION) for $(BUILD_PLATFORMS)
 	gox $(BUILD_PLATFORMS) \
 		-ldflags "$(GO_LDFLAGS)" \
@@ -186,16 +116,32 @@
 		-o "out/binaries/$(NAME)" \
 		$(PKG)
 
-build_current: executors/docker/bindata.go build_simple
-
-check_race_conditions: executors/docker/bindata.go
+build_current: docker build_simple
+
+check_race_conditions:
 	@./scripts/check_race_conditions $(OUR_PACKAGES)
 
-test: executors/docker/bindata.go
+test: $(PKG_BUILD_DIR) docker
 	# Running tests...
 	go test $(OUR_PACKAGES) $(TESTFLAGS)
 
-install: executors/docker/bindata.go
+parallel_test_prepare: $(GOPATH_SETUP)
+	# Preparing test commands
+	@./scripts/go_test_with_coverage_report prepare
+
+parallel_test_execute: $(GOPATH_SETUP) pull_images_for_tests
+	# executing tests
+	@./scripts/go_test_with_coverage_report execute
+
+parallel_test_coverage_report: $(GOPATH_SETUP)
+	# Preparing coverage report
+	@./scripts/go_test_with_coverage_report coverage
+
+pull_images_for_tests: $(GOPATH_SETUP)
+	# Pulling images required for some tests
+	@go run ./scripts/pull-images-for-tests/main.go
+
+install:
 	go install --ldflags="$(GO_LDFLAGS)" $(PKG)
 
 dockerfiles:
@@ -237,7 +183,7 @@
 
 package-deps:
 	# Installing packaging dependencies...
-	gem install rake fpm --no-ri --no-rdoc
+	which fpm 1>/dev/null || gem install rake fpm --no-ri --no-rdoc
 
 package-prepare:
 	chmod 755 packaging/root/usr/share/gitlab-runner/
@@ -283,7 +229,12 @@
 		--deb-suggests docker-engine \
 		-a $(PACKAGE_ARCH) \
 		packaging/root/=/ \
-		out/binaries/$(NAME)-linux-$(ARCH)=/usr/bin/gitlab-runner
+		out/binaries/$(NAME)-linux-$(ARCH)=/usr/lib/gitlab-runner/gitlab-runner \
+		out/helper-images/=/usr/lib/gitlab-runner/helper-images/
+	@if [ -n "$(GPG_KEYID)" ]; then \
+		dpkg-sig -g "--no-tty --digest-algo 'sha512' --passphrase '$(GPG_PASSPHRASE)'" \
+			-k $(GPG_KEYID) --sign builder "out/deb/$(PACKAGE_NAME)_$(PACKAGE_ARCH).deb" ;\
+	fi
 
 package-rpm-fpm:
 	@mkdir -p out/rpm/
@@ -308,7 +259,16 @@
 		--depends tar \
 		-a $(PACKAGE_ARCH) \
 		packaging/root/=/ \
-		out/binaries/$(NAME)-linux-$(ARCH)=/usr/bin/gitlab-runner
+		out/binaries/$(NAME)-linux-$(ARCH)=/usr/lib/gitlab-runner/gitlab-runner \
+		out/helper-images/=/usr/lib/gitlab-runner/helper-images/
+	@if [ -n "$(GPG_KEYID)" ] ; then \
+		echo "yes" | setsid rpm \
+			--define "_gpg_name $(GPG_KEYID)" \
+			--define "_signature gpg" \
+			--define "__gpg_check_password_cmd /bin/true" \
+			--define "__gpg_sign_cmd %{__gpg} gpg --batch --no-armor --digest-algo 'sha512' --passphrase '$(GPG_PASSPHRASE)' --no-secmem-warning -u '%{_gpg_name}' --sign --detach-sign --output %{__signature_filename} %{__plaintext_filename}" \
+			--addsign out/rpm/$(PACKAGE_NAME)_$(PACKAGE_ARCH).rpm ;\
+	fi
 
 packagecloud: packagecloud-deps packagecloud-deb packagecloud-rpm
 
@@ -319,3 +279,55 @@
 packagecloud-deb:
 	# Sending Debian compatible packages...
 	-for DIST in $(DEB_PLATFORMS); do \
+		package_cloud push --url $(PACKAGE_CLOUD_URL) $(PACKAGE_CLOUD)/$$DIST out/deb/*.deb; \
+	done
+
+packagecloud-rpm:
+	# Sending RedHat compatible packages...
+	-for DIST in $(RPM_PLATFORMS); do \
+		package_cloud push --url $(PACKAGE_CLOUD_URL) $(PACKAGE_CLOUD)/$$DIST out/rpm/*.rpm; \
+	done
+
+packagecloud-yank:
+ifneq ($(YANK),)
+	# Removing $(YANK) from packagecloud...
+	-for DIST in $(DEB_PLATFORMS); do \
+		for ARCH in $(DEB_ARCHS); do \
+			package_cloud yank --url $(PACKAGE_CLOUD_URL) $(PACKAGE_CLOUD)/$$DIST $(PACKAGE_NAME)_$(YANK)_$$ARCH.deb & \
+		done; \
+	done; \
+	for DIST in $(RPM_PLATFORMS); do \
+		for ARCH in $(RPM_ARCHS); do \
+			package_cloud yank --url $(PACKAGE_CLOUD_URL) $(PACKAGE_CLOUD)/$$DIST $(PACKAGE_NAME)-$(YANK)-1.$$ARCH.rpm & \
+		done; \
+	done; \
+	wait
+else
+	# No version specified in YANK
+	@exit 1
+endif
+
+s3-upload:
+	export ARTIFACTS_DEST=artifacts; curl -sL https://raw.githubusercontent.com/travis-ci/artifacts/master/install | bash
+	./artifacts upload \
+		--permissions public-read \
+		--working-dir out \
+		--target-paths "$(S3_UPLOAD_PATH)/" \
+		--max-size $(shell du -bs out/ | cut -f1) \
+		$(shell cd out/; find . -type f)
+	@echo "\n\033[1m==> Download index file: \033[36mhttps://$$ARTIFACTS_S3_BUCKET.s3.amazonaws.com/$$S3_UPLOAD_PATH/index.html\033[0m\n"
+
+release_packagecloud:
+	# Releasing to https://packages.gitlab.com/runner/
+	@./ci/release_packagecloud "$$CI_JOB_NAME"
+
+release_s3: prepare_windows_zip prepare_zoneinfo prepare_index
+	# Releasing to S3
+	@./ci/release_s3
+
+out/binaries/gitlab-runner-windows-%.zip: out/binaries/gitlab-runner-windows-%.exe
+	zip --junk-paths $@ $<
+	cd out/ && zip -r ../$@ helper-images
+
+prepare_windows_zip: out/binaries/gitlab-runner-windows-386.zip out/binaries/gitlab-runner-windows-amd64.zip
+

=== debian/changelog ===
gitlab-ci-multi-runner (11.2.0+dfsg-2ubuntu1) disco; urgency=medium

  * Fix ftbfs: 
    - Build-Depend on tzdata to fix test.
    - Build-Depend on golang-github-docker-distribution-dev directly.
    - d/patches/cliconfig-location.patch: look for the cli config packages in
      their new location.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 07 Feb 2019 22:05:01 +1300

gitlab-ci-multi-runner (11.2.0+dfsg-2) unstable; urgency=medium

  * New patch to fix FTBFS (Closes: #911437).
    Thanks, Andreas Henriksson.

 -- Dmitry Smirnov <onlyjob@debian.org>  Mon, 10 Dec 2018 07:27:43 +1100

gitlab-ci-multi-runner (11.2.0+dfsg-1) unstable; urgency=medium

  * New upstream release [August 2018].
  * Build-Depends:
    - golang-github-coreos-go-oidc-dev
    + golang-github-azure-go-autorest-dev
    + golang-github-googleapis-gnostic-dev
    + golang-github-gophercloud-gophercloud-dev
    + golang-github-howeyc-gopass-dev
    + golang-github-jpillora-backoff-dev
    + golang-github-json-iterator-go-dev
    = golang-github-sirupsen-logrus-dev (>= 1.0.6~)
  * Recommends += "xz-utils" (Closes: #908276).
    Thanks, Birger Schacht.

 -- Dmitry Smirnov <onlyjob@debian.org>  Tue, 11 Sep 2018 14:28:47 +1000

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,17 @@
 Source: gitlab-ci-multi-runner
 Section: devel
 Priority: optional
-Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
 Uploaders: Dmitry Smirnov <onlyjob@debian.org>
 Build-Depends: debhelper (>= 11~) ,dh-golang
               ,golang-go (>= 2:1.7~)
     ,golang-github-azure-go-ansiterm-dev
+    ,golang-github-azure-go-autorest-dev
     ,golang-github-blang-semver-dev
     ,golang-github-burntsushi-toml-dev
-    ,golang-github-coreos-go-oidc-dev (>= 0.0~git20160926~)
+#~  ,golang-github-coreos-go-oidc-dev (>= 0.0~git20160926~)
+    ,golang-github-docker-distribution-dev
     ,golang-github-docker-docker-credential-helpers-dev (>= 0.5.0~)
     ,golang-github-docker-docker-dev (>= 17.12.1~)
     ,golang-github-docker-go-connections-dev (>= 0.3.0~)
@@ -19,13 +22,18 @@
     ,golang-github-getsentry-raven-go-dev
     ,golang-github-ghodss-yaml-dev
     ,golang-github-go-ini-ini-dev
+    ,golang-github-googleapis-gnostic-dev
     ,golang-github-google-cadvisor-dev
     ,golang-github-google-gofuzz-dev
+    ,golang-github-gophercloud-gophercloud-dev
     ,golang-github-gorhill-cronexpr-dev
     ,golang-github-gorilla-context-dev
     ,golang-github-gorilla-mux-dev
     ,golang-github-hashicorp-go-version-dev
+    ,golang-github-howeyc-gopass-dev
     ,golang-github-imdario-mergo-dev
+    ,golang-github-jpillora-backoff-dev
+    ,golang-github-json-iterator-go-dev
     ,golang-github-juju-ratelimit-dev
     ,golang-github-mattn-go-zglob-dev
     ,golang-github-minio-minio-go-dev (>= 4.0.5~)
@@ -34,8 +42,8 @@
     ,golang-github-pborman-uuid-dev
     ,golang-github-pkg-errors-dev
     ,golang-github-pmezard-go-difflib-dev
-    ,golang-github-prometheus-client-golang-dev
-    ,golang-github-sirupsen-logrus-dev (>= 1.0.5~)
+    ,golang-github-prometheus-client-golang-dev (>= 0.9.0~)
+    ,golang-github-sirupsen-logrus-dev (>= 1.0.6~)
     ,golang-github-spf13-pflag-dev
     ,golang-github-stretchr-testify-dev (>= 1.2.1~)
     ,golang-github-urfave-cli-dev
@@ -48,6 +56,7 @@
     ,ca-certificates
     ,git
     ,golang-github-golang-mock-dev
+    ,tzdata
 Standards-Version: 4.1.4
 Homepage: https://gitlab.com/gitlab-org/gitlab-runner
 Vcs-Browser: https://salsa.debian.org/go-team/packages/gitlab-ci-multi-runner
@@ -70,6 +79,7 @@
     ,lsb-base
 Recommends: ${misc:Recommends}
     ,cdebootstrap
+    ,xz-utils
 Suggests: ${misc:Suggests}
     ,docker.io
 Description: GitLab Runner - runs continuous integration (CI) jobs

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
VER  ?= $(shell sh -c 'printf "$${1%%+dfsg*}"' -- "$(DEB_VERSION_UPSTREAM)")

export DH_GOLANG_GO_GENERATE := 1
export DH_GOPKG = gitlab.com/gitlab-org/gitlab-runner
export DH_GOPKG_common = $(DH_GOPKG)/common
#export DH_GOLANG_INSTALL_EXTRA := vendor
#export DH_GOLANG_INSTALL_ALL := 1
#export DH_GOLANG_EXCLUDES = apps/gitlab-runner-helper

## Set some build variables as per Makefile:
GO_LDFLAGS ?= \
    -X $(DH_GOPKG_common).VERSION=$(VER) \
    -X $(DH_GOPKG_common).REVISION=$(VER)
#    -X $(DH_GOPKG_common).NAME=$(DEB_SOURCE)
#    -X $(DH_GOPKG_common).BUILT=$(BUILT)
#    -X $(DH_GOPKG_common).BRANCH=$(BRANCH)

MKPI=debian/mk-prebuilt-images.sh

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

override_dh_clean:
	dh_clean $(MKPI)
	## Remove Files-Excluded (when built from checkout or non-DFSG tarball):
	$(RM) -rv `perl -0nE 'say $$1 if m{^Files\-Excluded\:\s*(.*?)(?:\n\n|Files:|Comment:)}sm;' debian/copyright`
	-find vendor -type d -empty -delete -print
	-find . -type f -name '*.generated.go' -print -delete ## delete .generated.go files

$(MKPI):
	sed -e 's/__VERSION__/$(VER)/g' $@.in > $@
	chmod --reference=$@.in $@

GITDIR=_build/src/$(DH_GOPKG)/tmp/gitlab-test
$(GITDIR):
	mkdir -v -p $@
	cd $@ && git init

override_dh_auto_configure: $(MKPI) $(GITDIR)
	dh_auto_configure

override_dh_auto_build:
	dh_auto_build --parallel -- \
            -ldflags "$(GO_LDFLAGS)"

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp

override_dh_auto_test:
	mkdir -v -p $(CURDIR)/debian/tmp
	HOME=$(CURDIR)/debian/tmp \
        dh_auto_test --max-parallel=4 -- \
            -ldflags "$(GO_LDFLAGS)"
#-test.short

=== debian/watch ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 opts="\
 pgpmode=none,\
-repacksuffix=+dfsg1,\
+repacksuffix=+dfsg,\
 repack,compression=xz,\
 dversionmangle=s{[+~]dfsg\d*}{},\
 " https://gitlab.com/gitlab-org/gitlab-runner/tags \

## gitlab-ci-multi-runner 12.1.0+dfsg

=== debian/changelog ===
gitlab-ci-multi-runner (12.1.0+dfsg-1) unstable; urgency=medium

  * New upstream release [July 2019] (Closes: #933087).
  * Standards-Version: 4.4.0.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 27 Jul 2019 12:12:23 +1000

gitlab-ci-multi-runner (12.0.1+dfsg-1) unstable; urgency=medium

  [ Dmitry Smirnov ]
  * New upstream release [June 2019] (Closes: #924532, #921530).
  * B-D tightening: golang-github-minio-minio-go-dev (>= 6.0.11~)
  * Standards-Version: 4.3.0
  * Set myself as Maintainer.
  * Build-Depends:
    - golang-github-google-cadvisor-dev

  [ Michael Hudson-Doyle ]
  * Build-Depend on tzdata.
    At least one test fails without tzdata installed
  * restore golang-github-docker-distribution-dev to Build-Depends
    this package still imports github.com/docker/distribution/reference directly
    (in executors/docker/executor_docker.go) so should still have it in B-D.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 29 Jun 2019 17:27:53 +1000

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,8 @@
 Source: gitlab-ci-multi-runner
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
-Uploaders: Dmitry Smirnov <onlyjob@debian.org>
+Maintainer: Dmitry Smirnov <onlyjob@debian.org>
+Uploaders: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
 Build-Depends: debhelper (>= 11~) ,dh-golang
               ,golang-go (>= 2:1.7~)
     ,golang-github-azure-go-ansiterm-dev
@@ -23,7 +22,6 @@
     ,golang-github-ghodss-yaml-dev
     ,golang-github-go-ini-ini-dev
     ,golang-github-googleapis-gnostic-dev
-    ,golang-github-google-cadvisor-dev
     ,golang-github-google-gofuzz-dev
     ,golang-github-gophercloud-gophercloud-dev
     ,golang-github-gorhill-cronexpr-dev
@@ -36,7 +34,7 @@
     ,golang-github-json-iterator-go-dev
     ,golang-github-juju-ratelimit-dev
     ,golang-github-mattn-go-zglob-dev
-    ,golang-github-minio-minio-go-dev (>= 4.0.5~)
+    ,golang-github-minio-minio-go-dev (>= 6.0.11~)
     ,golang-github-opencontainers-runc-dev (>= 1.0.0~)
     ,golang-github-opencontainers-specs-dev (>= 1.0.1~)
     ,golang-github-pborman-uuid-dev
@@ -57,7 +55,7 @@
     ,git
     ,golang-github-golang-mock-dev
     ,tzdata
-Standards-Version: 4.1.4
+Standards-Version: 4.4.0
 Homepage: https://gitlab.com/gitlab-org/gitlab-runner
 Vcs-Browser: https://salsa.debian.org/go-team/packages/gitlab-ci-multi-runner
 Vcs-Git: https://salsa.debian.org/go-team/packages/gitlab-ci-multi-runner.git
